import { Iterable } from './Iterable'
import { collect } from './Collection'

/**
 * A basic Iterable implementation that uses an array as a backend.
 * @extends Iterable
 */
export class ArrayIterable<T> extends Iterable<T> {
    constructor(
        /**
         * Items to use for this iterable.
         */
        protected items: T[],
    ) {
        super()
    }

    async at(i: number) {
        return this.items[i]
    }

    async range(start: number, end: number) {
        return collect(this.items.slice(start, end + 1))
    }

    async count() {
        return this.items.length
    }

    clone() {
        return new ArrayIterable([...this.items])
    }
}
