
export function isDebugging(key: string): boolean {
    const env = 'EXTOLLO_DEBUG_' + key.split(/(?:\s|\.)+/).join('_').toUpperCase()
    return process.env[env] === 'yes'
}

export function ifDebugging(key: string, run: () => any) {
    if ( isDebugging(key) ) run()
}

export function logIfDebugging(key: string, ...output: any[]) {
    ifDebugging(key, () => console.log(`[debug: ${key}]`, ...output))
}
